/*
* Copyright 2013 ComingX Jingle http://www.comingx.com
* 
* Licensed under the Apache License, Version 2.0 (the "License"); you may not
* use this file except in compliance with the License. You may obtain a copy of
* the License. You may obtain a copy of the License at
* 
*  http://www.apache.org/licenses/LICENSE-2.0
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
* WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
* License for the specific language governing permissions and limitations under
* the License.
*/

package com.comingx.jingle.chinamap.utils
{
	public class ColorUtil
	{
		public function ColorUtil()
		{
		}
		
		/**
		 * 计算value对应的颜色值
		 */ 
		public static function caculateColor(value:Number,startColor:uint,endColor:uint,startValue:Number,endValue:Number):uint
		{
			var rs:uint = startColor >> 16 & 0xff;
			var gs:uint = startColor >> 8 & 0xff;
			var bs:uint = startColor & 0xff;
			var re:uint = endColor >> 16 & 0xff;
			var ge:uint = endColor >> 8 & 0xff;
			var be:uint = endColor & 0xff;
			
			var rx:uint = ColorUtil.mappingColor(value,rs,re,startValue,endValue);
			var gx:uint = ColorUtil.mappingColor(value,gs,ge,startValue,endValue);
			var bx:uint = ColorUtil.mappingColor(value,bs,be,startValue,endValue);
			
			return rx << 16 | gx << 8 | bx;
		}
		
		private static function mappingColor(value:Number,startColor:uint,endColor:uint,startValue:Number,endValue:Number):uint
		{
			return (value - startValue) / (endValue - startValue) * (endColor - startColor) + startColor;
		}
	}
}